/*
 * - ----------
   Плагин - "Male sexual organ"
 * - ----------
   Описание: Добавляет игрокам мужской половой орган между ног. Забавная атмосфера обеспечена!
 * - ----------
   Поддержка плагина:

   Dev-Cs: @wellasgood
   Telegram: @WellAsGood
 * - ----------
   Благодарности:

   Limbooc - за модельку.
   Subb98 - за способ работы с entity на reapi.
   Алексеич - за баг-репорт.
  * - ----------
*/

/*
   Журнал изменений:

   ver 1.0.1:

   1. Исправлено название плагина, на правильное по смыслу.
   2. Название папки модели и модели в архиве было старое (исправлено)
   3. Изменен исходник в некоторых частях, с учетом новых обновлений.

   ver 1.1.0:

   1. Сделана еще 1 модель полового органа больше в размерах.
   2. Добавлено 2 новых режима:
       а) Большой+малый половой орган добавляется игрокам в рандом режиме.
       б) Большой половой орган добавляется только игрокам с нужным флагом.
   3. Добавлена возможность отключить иммунитет дефайном.
   4. Изменен код, с учетом новых обновлений.

   ver 1.1.1:

   1. Поправлены значения в функции random_num. (правильные по замыслу, что-бы было понятней)

   ver 1.1.2:

   1. В ходе тестирования было обнаружены ошибки при компилировании, в зависимости от разных режимов (исправлено, спасибо: Алексеич)
*/

#include <amxmodx>
#include <reapi>

#define USE_IMMUNITY //Использование иммунитета от модели полового органа.

#if defined USE_IMMUNITY
 #define IMMUNITY_ORGAN_FLAG ADMIN_RCON //защищает игрока с этим флагом от модельки полового органа.
#endif

#define USE_BIG_MODE //Использование большого полового органа. (входит несколько режимов)

#if defined USE_BIG_MODE
 #define USE_MODE_RANDOM //Режим большого и малого полового органа (игрокам добавляется рандом моделька между ними)

 #if !defined USE_MODE_RANDOM
  //Если #define USE_MODE_RANDOM закомментирован, то:
  //Режим большого полового органа, моделька добавляется только тому у кого нужный флаг!
  //Игрокам с этим флагом будет добавляться моделька большого полового органа. (всем остальным маленький)
  #define BIG_ORGAN_FLAG ADMIN_BAN
 #endif

 new const BIG_ORGAN_MODEL[] = "models/sexual_organ/bg_sexual_organ.mdl";
#endif

#define USE_BOTS //Использование ботов (если откомментировано, то на ботах тоже будет половой орган)

new const PLUGIN[] = "Male_sexual_organ";
new const VERSION[] = "1.1.2";
new const AUTHOR[] = "wellasgood";

new const SMALL_ORGAN_MODEL[] = "models/sexual_organ/sm_sexual_organ.mdl";

new Entity[MAX_PLAYERS+1], ModelIndex[2], bool:Check[MAX_PLAYERS+1];

public plugin_precache()
{
	#if defined USE_BIG_MODE
	CheckModels(BIG_ORGAN_MODEL, 1);
	#endif

	CheckModels(SMALL_ORGAN_MODEL, 0);
}

CheckModels(const model[], num)
{
	if(!file_exists(fmt("\%s", model)))
	{
		set_fail_state("Error! Model '%s' not found", model);
	}
	else
	{
		ModelIndex[num] = precache_model(model);
	}
}

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);

	RegisterHookChain(RG_CBasePlayer_Spawn, "@EventSpawn", true);
}

public client_putinserver(PlayerID)
{
	#if !defined USE_BOTS
	if(is_user_bot(PlayerID))
	{
		return;
	}
	#endif

	if(is_user_hltv(PlayerID))
	{
		return;
	}

	#if defined USE_IMMUNITY
	if(get_user_flags(PlayerID) & IMMUNITY_ORGAN_FLAG)
	{
		return;
	}
	#endif

	Check[PlayerID] = false;

	new check_model;

	#if !defined USE_BIG_MODE
	check_model = 1;
	#else
	#if !defined USE_MODE_RANDOM
	if(get_user_flags(PlayerID) & BIG_ORGAN_FLAG)
	{
		check_model = 2;
	}
	else
	{
		check_model = 1;
	}
	#else
	check_model = random_num(1, 2);
	#endif
	#endif

	CreateEnt(PlayerID, check_model);
}

public client_disconnected(PlayerID)
{
	RemoveOrgan(PlayerID);
}

@EventSpawn(PlayerID)
{
	if(!is_user_alive(PlayerID) || Check[PlayerID])
	{
		return;
	}

	SetOrgan(PlayerID);
}

SetOrgan(PlayerID)
{
	if(Entity[PlayerID] && is_entity(Entity[PlayerID]))
	{
		set_entvar(Entity[PlayerID], var_body, 0);
		Check[PlayerID] = true;
	}
}

RemoveOrgan(PlayerID)
{
	if(Entity[PlayerID] && is_entity(Entity[PlayerID]))
	{
		set_entvar(Entity[PlayerID], var_flags, FL_KILLME);
		set_entvar(Entity[PlayerID], var_nextthink, get_gametime());
		Entity[PlayerID] = 0;
	}
}

CreateEnt(PlayerID, check_model)
{
	if((Entity[PlayerID] = rg_create_entity("info_target")))
	{
		set_entvar(Entity[PlayerID], var_classname, "_male_sexual_organ");
		#if !defined USE_BIG_MODE
		set_entvar(Entity[PlayerID], var_model, SMALL_ORGAN_MODEL);
		#else
		set_entvar(Entity[PlayerID], var_model, check_model == 1 ? SMALL_ORGAN_MODEL : BIG_ORGAN_MODEL);
		#endif
		set_entvar(Entity[PlayerID], var_modelindex, check_model == 1 ? ModelIndex[0] : ModelIndex[1]);
		set_entvar(Entity[PlayerID], var_movetype, MOVETYPE_FOLLOW);
		set_entvar(Entity[PlayerID], var_aiment, PlayerID);
	}
}